import java.awt.*;

class Edge
{
    public Vertex v1;
    public Vertex v2;
    public int weight;
    private boolean marked;

    public Edge(Vertex vertex, Vertex vertex1, int i)
    {
        v1 = vertex;
        v2 = vertex1;
        weight = i;
        marked = false;
    }

    public void mark()
    {
        marked = true;
    }

    public void unmark()
    {
        marked = false;
    }

    public boolean marked()
    {
        return marked;
    }

    public void draw(Graphics g, Dimension dimension, boolean flag)
    {
        g.setColor(marked ? Color.yellow : Color.white);
        int i = (int)((double)dimension.width * v1.x);
        int j = (int)((double)dimension.height * v1.y);
        int k = (int)((double)dimension.width * v2.x);
        int l = (int)((double)dimension.height * v2.y);
        g.drawLine(i, j, k, l);
        if(marked)
            if((i - k) * (j - l) >= 0)
            {
                if(i != k)
                    g.drawLine(i, j + 1, k, l + 1);
                if(j != l)
                    g.drawLine(i + 1, j, k + 1, l);
            }
            else
            {
                g.drawLine(i + 1, j, k + 1, l);
                g.drawLine(i, j - 1, k, l - 1);
            }
        v1.draw(g, dimension);
        v2.draw(g, dimension);
        if(flag)
        {
            int i1 = (i + k >> 1) - 5;
            int j1 = (j + l >> 1) + 4;
            g.setColor(Color.white);
            g.drawString(String.valueOf(weight), i1, j1);
        }
    }

}