import java.awt.Component;
import java.awt.Panel;
import java.util.Vector;

class Graph
{

    public Graph()
    {
        edges = new Vector();
        vertices = new Vector();
    }

    public int numEdges()
    {
        return edges.size();
    }

    public int numVertices()
    {
        return vertices.size();
    }

    public Edge edge(int i)
    {
        return (Edge)edges.elementAt(i);
    }

    public Vertex vertex(int i)
    {
        return (Vertex)vertices.elementAt(i);
    }

    public Vertex addVertex(double d, double d1)
    {
        Vertex vertex1 = new Vertex(d, d1);
        vertices.addElement(vertex1);
        return vertex1;
    }

    public Edge addEdge(Vertex vertex1, Vertex vertex2, int i)
    {
        Edge edge1 = new Edge(vertex1, vertex2, i);
        edges.addElement(edge1);
        return edge1;
    }

    public void draw(Panel panel, boolean flag)
    {
        java.awt.Graphics g = panel.getGraphics();
        java.awt.Dimension dimension = panel.size();
        for(int i = 0; i < numEdges(); i++)
        {
            Edge edge1 = edge(i);
            edge1.draw(g, dimension, flag);
        }

    }

    public void reset()
    {
        ColorPalette.count = 0;
        for(int i = 0; i < numEdges(); i++)
            edge(i).unmark();

        for(int j = 0; j < numVertices(); j++)
            vertex(j).reset();

    }

    private Vector edges;
    private Vector vertices;
}