import java.util.Vector;

class Kruskal
{

    public void start(Graph graph)
    {
        weight = 0;
        index = 0;
        sortEdges(graph, MST.MAX_WEIGHT);
    }

    private void sortEdges(Graph graph, int i)
    {
        Vector avector[] = new Vector[i];
        for(int j = 0; j < i; j++)
            avector[j] = new Vector();

        for(int k = 0; k < graph.numEdges(); k++)
        {
            Edge edge = graph.edge(k);
            int i1 = edge.weight - 1;
            avector[i1].addElement(edge);
        }

        if(edges == null)
            edges = new Vector();
        else
            edges.removeAllElements();
        for(int l = 0; l < i; l++)
        {
            Vector vector = avector[l];
            for(int j1 = 0; j1 < vector.size(); j1++)
                edges.addElement(vector.elementAt(j1));

            vector.removeAllElements();
        }

    }

    public boolean step()
    {
        if(edges == null || index >= edges.size())
            return false;
        while(index < edges.size()) 
        {
            Edge edge = (Edge)edges.elementAt(index++);
            VertexLabel vertexlabel = edge.v1.getLabel();
            VertexLabel vertexlabel1 = edge.v2.getLabel();
            if(vertexlabel != vertexlabel1)
            {
                edge.mark();
                weight += edge.weight;
                if(vertexlabel.size < vertexlabel1.size)
                    vertexlabel1.union(edge.v1);
                else
                    vertexlabel.union(edge.v2);
                return true;
            }
        }

        return false;
    }

    Kruskal()
    {
    }

    public int weight;
    private int index;
    private Vector edges;
}