import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class MST extends Applet
{

    public static void CountOp()
    {
        op_count++;
    }

    private void showSize(int i)
    {
        size_field.setText(String.valueOf(i));
    }

    private void showCost()
    {
        edge_field.setText(String.valueOf(G.numEdges()));
        cost_field.setText(String.valueOf(op_count));
    }
    

    public void init()
    {
        solver = new Kruskal();
        show_weights = true;
        curr_size = 0;
        next_size = 3;
        setFont(new Font("Helvetica", 1, 12));
        top = new Panel();
        bottom = new Panel();
        disp = new Panel();
        
        top.setBackground(Color.black);
        top.setForeground(Color.white);
        disp.setBackground(Color.black);
        top.setLayout(new FlowLayout());
        bottom.setLayout(new FlowLayout());
        bottom.setBackground(Color.black);
        bottom.setForeground(Color.white);
        
        reset = new Button("Start");
        step = new Button("Step");
        solve = new Button("Compute");
        
        reset.setForeground(Color.green);
        step.setForeground(Color.green);
        solve.setForeground(Color.green);

        
        size_field = new TextField(2);
        weight_field = new TextField(6);
        edge_field = new TextField(4);
        cost_field = new TextField(8);
        
        size_field.setBackground(Color.lightGray);
        weight_field.setBackground(Color.lightGray);
        edge_field.setBackground(Color.lightGray);
        cost_field.setBackground(Color.lightGray);

        size_field.disable();
        weight_field.disable();
        edge_field.disable();
        cost_field.disable();

        //group = new CheckboxGroup();
        //show = new Checkbox("Show weights", group, true);
        show = new Checkbox("Show weights", true);
        //hide = new Checkbox("Hide weights", group, false);
        bottom.add(reset);
        bottom.add(step);
        bottom.add(solve);
        bottom.add(size_field);
        bottom.add(weight_field);
        bottom.add(show);
        //bottom.add(hide);
        bottom.add(new Label("Number of edges", 2));
        bottom.add(edge_field);
        bottom.add(new Label("Cost", 2));
        bottom.add(cost_field);
        setLayout(new BorderLayout());
        int i;
        Label lb = new Label("NxN Node"); 
        lb.setForeground(Color.white);
        slider = new Scrollbar(Scrollbar.HORIZONTAL, 20 - ((i = curr_size) - 3),
                 1, 3, 20);
        
        Panel header = new Panel();
        header.setBackground(Color.black);
        header.setForeground(Color.magenta);

        header.setLayout(new GridLayout(2,1));
        Panel title = new Panel();
        title.add(new Label("Kruskal's Algorithm : The Greedy One"));
        title.setFont(new Font("Helvetica", Font.BOLD, 14));

        Panel sld = new Panel();
        sld.setFont(new Font("Helvetica", Font.BOLD, 12));
        sld.setBackground(new Color(100,100,200));
        sld.setForeground(Color.black);
        sld.setLayout(new BorderLayout());
        sld.add(new Label("Move Scrollbar for new graph", Label.CENTER), BorderLayout.NORTH);
        sld.add(new Label(" start"), BorderLayout.EAST);
        sld.add(new Label(" end"), BorderLayout.WEST);
        sld.add(new Label("  "), BorderLayout.SOUTH);
        sld.add(slider, BorderLayout.CENTER);
         
        header.add(title);
        header.add(bottom);
        add("Center", disp);
        add("South", sld);
        add("North", header);
        //add("East", slider);
    }
    
    class MyScrollbar extends Scrollbar {
    	Label position;
    	String direction = "    Horizontal";
    	public MyScrollbar(int ori, int val, int visible,
    	                   int min, int max, Label label) {
    		super(ori, val, visible, min, max);
    		position = label;
    		position.setForeground(Color.green);
    		addAdjustmentListener(new MyScrollbar.HandleScrolling());
     }
     
     class HandleScrolling implements AdjustmentListener {
     	public void adjustmentValueChanged(AdjustmentEvent e) {
     		position.setText(direction +" Position: " +e.getValue());
     	}
     }
    }

    public void start()
    {
    	repaint();
        if(G == null)
        {
            newProblem(next_size);
            solver.start(G);
        } else {
        	repaint();
        }
    }

    public void update(Graphics g)
    {
        G.draw(disp, show_weights);
        weight_field.setText(String.valueOf(solver.weight));
        cost_field.setText(String.valueOf(op_count));
        int i = curr_size;
        size_field.setText(String.valueOf(i));
    }

    public void paint(Graphics g)
    {
        clear();
        update(g);
    }

    public void clear()
    {
        Graphics g = disp.getGraphics();
        Dimension dimension = disp.size();
        g.setColor(Color.black);
        g.fillRect(0, 0, dimension.width, dimension.height);
    }

    private void newProblem(int i)
    {
        op_count = 0;
        if(i == curr_size && G != null)
        {
            G.reset();
        }
        else
        {
            curr_size = i;
            G = MakeGraph.grid(curr_size);
            int j = curr_size;
            size_field.setText(String.valueOf(j));
            showCost();
        }
        solve.enable();
        step.enable();
        solver.start(G);
        clear();
        repaint();
    }

    public boolean handleEvent(Event event)
    {
        if(event.target == slider)
        {
            switch(event.id)
            {
            case 1005: // Event.LOST_FOCUS
                newProblem(next_size);
                return true;

            case 601: // Event.SCROLL_LINE_UP
            case 602: // Event.SCROLL_LINE_DOWN
            case 603: // Event.SCROLL_PAGE_UP
            case 604: // Event.SCROLL_PAGE_DOWN
            case 605: // Event.SCROLL_ABSOLUTE
                int i;
                next_size = 20 - ((i = slider.getValue()) - 3);
                i = next_size;
                size_field.setText(String.valueOf(i));
                return true;

            }
            return false;
        }
        if(event.target == reset && event.id == 1001)
        {
            newProblem(next_size);
            ColorPalette.count = 0;
            return true;
        }
        if(event.target == step && event.id == 1001)
        {
            if(solver.step())
            {
                repaint();
            }
            else
            {
                solve.disable();
                step.disable();
                reset.enable();
            }
            return true;
        }
        if(event.target == show && event.id == 1001)
        {
            if (show.getState()) {
            	show_weights = true;
            } else {
              show_weights = false;
              clear();
            }
            repaint();
        }
        
        /*
                else
        if(event.target == hide && event.id == 1001)
        {
            show_weights = false;
            clear();
            repaint();
        }
        */
        else
        if(event.target == solve && event.id == 1001)
        {
            while(solver.step()) ;
            repaint();
            solve.disable();
            step.disable();
            reset.enable();
            return true;
        }
        return false;
    }

    private int Flip(int i)
    {
        return 20 - (i - 3);
    }

    public MST()
    {
    }

    public static int MAX_WEIGHT = 10;
    public static int op_count;
    private int curr_size;
    private int next_size;
    private Panel disp;
    private Panel top;
    private Panel bottom;
    private Button reset;
    private Button step;
    private Button solve;
    private TextField weight_field;
    private TextField size_field;
    private TextField edge_field;
    private TextField cost_field;
    private Scrollbar slider;
    private Graph G;
    private CheckboxGroup group;
    private Checkbox show;
    private Checkbox hide;
    private boolean show_weights;
    private Kruskal solver;
    private static final int MinVert = 3;
    private static final int MaxVert = 20;
    private static final int align = 2;

}